#include <cstdio>
#include <cassert>
using namespace std;

const int N = 202;

int in[N][N];
int vis[N][N];
int w, h;
int iter = 0;

int vx[] = {1, 1, -1, -1}, vy[] = {1, -1, 1, -1};

inline bool ok(int y, int x)
{
    return 1 <= y && y <= h && 1 <= x && x <= w;
}

void check()
{
    bool bad = false;
    for (int r = 1; !bad && r <= h; r++)
        for (int c = 1; !bad && c <= w; c++)
        {
            iter++;
            if (!in[r][c])
                continue;
            vis[r][c] = iter;
            for (int v = 0; !bad && v < 4; v++)
            {
                int dy = vy[v];
                int dx = vx[(v + 1) & 3];
                for (int y = r; !bad && y != 0 && y != h + 1; y += dy)
                    for (int x = c; !bad && x != 0 && x != c + 1; x += dx)
                    {
                        if (vis[y][x] == iter)
                        {
                            if (ok(y + dy, x) && in[y + dy][x])
                                vis[y + dy][x] = iter;
                            if (ok(y, x + dx) && in[y][x + dx])
                                vis[y][x + dx] = iter;
                        }
                        else
                        {
                            if (in[y][x])
                                bad = true;
                        }
                    }
            }
      }
      if (bad)
          puts("NO");
      else
          puts("YES");
}

int main()
{
    assert(freopen("turtles.in", "r", stdin));
    assert(freopen("turtles.out", "w", stdout));
    int n;
    assert(scanf("%d %d", &h, &w));
    assert(scanf("%d", &n));
    assert(w <= 200 && h <= 200);
    for (int i = 0; i < n; i++)
    {
        int r, c;
        assert(scanf("%d %d", &r, &c));
        in[r][c] = true;
    }
    check();
    int q;
    assert(scanf("%d", &q));
    for (int i = 0; i < q; i++)
    {
        int r, c;
        assert(scanf("%d %d", &r, &c));
        in[r][c] = true;
        check();
    }
}
